/**

 * @author strike

 */

function statBox() {

	//Methods

	this.init = init;

	this.add = add;

	this.getImage = getImage;

	this.timedSwitch = timedSwitch;

	this.makeGraph = makeGraph;

	

	//Properties

	this.images = Array();

	this.items = Array();

	this.picBox;

	this.selected;

	this.timer;

	this.time;

	this.hasItems = false;

	

	function init(interval) {

		this.time = interval;

		var divs = document.getElementsByTagName("a");

		for (var i=0; i < divs.length; i++) {

			if (divs[i].rel == "statBox[]") {

				this.add(divs[i]);

			}

		}

	}

	

	function add(box) {

		var obj = this;

		box.className = "statBox";

		var items = box.getElementsByTagName("span");

		this.items = items;

		for (var i = 0; i < items.length; i++) {

			if (i == 0) {

				this.hasItems = true;

				items[i].className = "statBoxNameActive";

				this.images[i] = document.createElement("div");

				wrapper = document.createElement("div");

				wrapper.id = "statBoxPicture"+i;

				wrapper.style.marginLeft = "3px";

				this.images[i].appendChild(wrapper);

				this.images[i].className = "statPictureBox";

				box.appendChild(this.images[i]);

				this.makeGraph(wrapper.id,items[i].title);

				items[i].title = "";

				items[i].key = i;

				this.selected = i;

				items[i].onclick = function () {

					obj.items[obj.selected].className = "statBoxName";

					obj.images[obj.selected].style.display = "none";

					obj.selected = this.key;

					obj.images[this.key].style.display = "block";

					this.className = "statBoxNameActive";

					clearInterval(obj.timer);

					obj.timer = setInterval(function () { timedSwitch(obj) },obj.time);

				} 

			}

			else {

				items[i].className = "statBoxName";

				this.images[i] = document.createElement("div");

				wrapper = document.createElement("div");

				wrapper.id = "statBoxPicture"+i;

				wrapper.style.marginLeft = "3px";

				this.images[i].appendChild(wrapper);

				this.images[i].className = "statPictureBox";

				box.appendChild(this.images[i]);

				this.makeGraph(wrapper.id,items[i].title);

				this.images[i].style.display = "none";

				items[i].title = "";

				items[i].key = i;

				items[i].onclick = function () {

					obj.items[obj.selected].className = "statBoxName";

					obj.images[obj.selected].style.display = "none";

					obj.selected = this.key;

					obj.images[this.key].style.display = "block";

					this.className = "statBoxNameActive";

					clearInterval(obj.timer);

					obj.timer = setInterval(function () { timedSwitch(obj) },obj.time);

				}

			}

		}

		if (this.hasItems) {

			this.timer = setInterval(function(){

				timedSwitch(obj)

			}, this.time);

		}

	}

	

	function makeGraph(id,data) {

		line = eval(data);



		jQuery.jqplot(id, [line], {

		  series:[{renderer:jQuery.jqplot.BarRenderer}],

		  axes: {

		    xaxis: {

		      renderer: jQuery.jqplot.CategoryAxisRenderer,

		      labelRenderer: jQuery.jqplot.CanvasAxisLabelRenderer,

		      tickRenderer: jQuery.jqplot.CanvasAxisTickRenderer,

		      tickOptions: {

	          angle: -30

		      }

		    },

		    yaxis: {

		      autoscale:true,

		      labelRenderer: jQuery.jqplot.CanvasAxisLabelRenderer,
		      
		      min: 0

		    }

		  },

		  axesDefaults: { tickOptions: { formatString: '%d' } },

		  seriesColors:  ['#0B55C4'],

		  grid:{shadow:false,shadowOffset:0 , borderWidth:0, background:'#fff'}

	

		});

	}

	

	function timedSwitch(obj) {

		obj.items[obj.selected].className = "statBoxName";

		obj.images[obj.selected].style.display = "none";

		if (obj.selected < obj.items.length - 1) {

			obj.selected++;

			

		}

		else {

			obj.selected = 0;

		}

		

		obj.items[obj.selected].className = "statBoxNameActive";

		obj.images[obj.selected].style.display = "block";

	}

	

	function getImage(dat) {

		var image = dat.replace("stat[","");

		image = image.replace("]","");

		return image;

	}

}



window.onload = function() {

	statbox = new statBox();

	statbox.init(5000);

}