<?php

/*

 * Author: David Abdul

 * Date: 07/06/2010

 * Description:

 * Object for eStara reports web service.

 */

ini_set('display_errors', 'On');

error_reporting(E_ALL);

 

class report {

	

	private $username;

	private $password;

	private $datatype;

	private $response;

    	

	public function report($user,$pass) {

		$this->username = $user;

		$this->password = $pass;

	}

	

	private function parseResponse($xml) {

		$doc = new DOMDocument();

		$doc->loadXML($xml);

		$error = $doc->getElementsByTagName("status");

		if ($error->length != 0) {

			if ($error->item(0)->getAttribute('code') == 2) {

				throw new Exception('Error: '.$error->item(0)->nodeValue);

			}

		} 

		$this->response = $doc->saveXML();

	}

	

	private function preparePost() {

		$doc = new DOMDocument();

		$root = $doc->appendChild($doc->createElement('Reporting'));

		$root->appendChild($doc->createElement('login',$this->username));

		$root->appendChild($doc->createElement('password',$this->password));

		$root->appendChild($doc->createElement('preset',$this->datatype));

		foreach ($this->vars as $key => $value) {

			$root->appendChild($doc->createElement($key,$value));

		}

		$response = $this->getUrl('https://as00.estara.com/webcare/reporting/xml.php',$doc->saveXML() );

		$this->parseResponse($response);

	}

	

	public function postRequest($datatype,$vars = array()) {

		$this->datatype = $datatype;

		$this->vars = $vars;

		$this->preparePost();

		return $this->response;

	}

	

	private function getUrl($url,$xml) {

		if (function_exists('curl_init')){

			$ch = curl_init($url);

			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);

			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);

			curl_setopt($ch, CURLOPT_POST, 1);

			curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type: text/xml'));

			curl_setopt($ch, CURLOPT_POSTFIELDS, "$xml");

			curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);

			$output = curl_exec($ch);

			$info = curl_getinfo($ch);

			if ($info['http_code'] != 200){

	            // not a valid response

	            if ($info['http_code'] == 400){

	                throw new Exception('Bad request (' . $info['http_code'] . ') url: ' . $url);     

	            }

	            if ($info['http_code'] == 403){

	                throw new Exception('Access denied (' . $info['http_code'] . ') url: ' . $url);     

	            }

	            throw new Exception('Not a valid response (' . $info['http_code'] . ') url: ' . $url);

	        }

			curl_close($ch);

			return $output;

		}

	}

}

/*Header is options, I only used it for displaying the result. You would obviously take the returned xml and parse and do what you feel from there.*/

//header("content-type: text/xml");

//$report = new report("luke@rsto.co.uk","yGvKRH9");

//echo $report->postRequest("today",array());

?>