<?php

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');



class seoModelgoogle extends JModel {

	

	var $fields;

	var $_record;

	var $formID;

	var $error = false;
	
	var $profiles;
	var $profileKeys;
	var $googleSettings;
	var $googleError = false;
	var $googleErrorMessage = '';

	

	function __construct() {

		

		try {

			$this->loadGoogle();
			
			$this->profiles = $this->google->getProfileList();				
			$this->profileKeys = array_keys($this->profiles);
			
			// go through profile keys to see if the profile id stored in the database is present
			$active_profile_id = 0;
			
			if($this->googleSettings['gprofileid'] != '' && !empty($this->profileKeys)){
				
				// Go through the profile keys from the Google account and match the
				// profile id to the one held in the database
				foreach($this->profileKeys as $profileIDFromGoogle){
					
					// We must put 'ga:' in front of the profile id when authorizing into google
					$profileIDFromDB = 'ga:' . $this->googleSettings['gprofileid']; 
					
					if($profileIDFromGoogle == $profileIDFromDB){
						$active_profile_id = $profileIDFromGoogle;
					}
				}
				
				// If a match was not found, use the first profile supplied by google
				if(!$active_profile_id){
					
					$this->googleError = true;
					$out = '<span style=\" color:#000; display:block; padding:10px;\"><h3>Profile ID not connected to Google Analytics account</h3>';
					$out .= '<p>The Profile ID you have provided is not available on the Google account you have specified.  Please ensure you have entered your profile ID correctly.</p></span>';
					$this->googleErrorMessage = $out;
				
				}
				
			} else {
				
				// If no profile id has been supplied by user, ask them to do so
				$this->googleError = true;
				$out = '<span style=\" color:#000; display:block; padding:10px;\"><h3>Profile ID not entered</h3>';
				$out .= '<p>You have not entered a Profile ID.  Please enter a Profile ID to enable your website statistics.</p></span>';
				$this->googleErrorMessage = $out;
			}
			
			// Set the profile ID 
			$this->google->setProfileById($active_profile_id);
			

    		$this->selectedMonth = date('n');
			$this->view = JRequest::getVar('display', 'graph');
			$date = JRequest::getVar('month', '');

			if ($date != "") {

				$this->selectedMonth = $date;

			}

			$this->google->setMonth($this->selectedMonth, date('Y')); 

		}

		catch (Exception $e) {
			
			$this->googleError = true;
			$out = '<span style=\" color:#000; display:block; padding:10px;\"><h3>Could not connect to Google Analytics</h3>';
			$out .= '<p>We could not connect to Google Analytics using the username and password you provided.  Please ensure you have entered your Google account details correctly.</p></span>';	
			$this->googleErrorMessage = $out;

		}

		//Construct the parent object

		parent::__construct();

	}

	

	private function loadGoogle() {

		$db =& JFactory::getDBO();

		$query = "SELECT `guser`,`gpass`,`gprofileid` FROM `#__seo_opts` WHERE `id`='1'";

		$db->setQuery($query);
		if (!$db->query()) {
			
			echo '<strong>Error:</strong> Your google account details could not be loaded from the database.';
			die();

		}

		$this->googleSettings = $db->loadAssoc();

		require JPATH_COMPONENT.DS.'lib'.DS.'analytics.class.php';

		$this->google = new analytics($this->googleSettings['guser'], base64_decode($this->googleSettings['gpass']));

	}

	

	public function build() {

		if ($this->googleError) {

			echo "<span style=\" color:#000; display:block; padding:10px;\">{$this->googleErrorMessage}</span>";

		}

		else {

			if ($this->view == "graph") {

				$this->getFilterForm();

	

				$this->getVisitors();

				$this->getPageViews();

				$this->getVisitsPerHour();

				

				$this->getBrowsers();

				$this->getKeywords();

				$this->getRefferers();

				$this->getResolutions();

			}

			else {

				$this->getFilterForm();

				

				$this->getBrowsers();

				$this->getKeywords();

				$this->getRefferers();

				echo '<div class="clear">&nbsp;</div><br /><br />';

				$this->getVisitors();

				$this->getPageViews();

				$this->getVisitsPerHour();

			}

		}

	}
	
	/**
	 * Returns true if SEM installed, false otherwise
	 * 
	 * @return Boolean true if installed, false otherwise
	 */
	public function semActive(){
		
		if($this->seoTableExists()){
			
			$db =& JFactory::getDBO();
			$query = "SELECT * FROM `#__seo_opts` WHERE `id`='1'";
			$db->setQuery($query);
			if (!$db->query()) {
				return false;
			}
			$details = $db->loadAssoc();
			
			// If the field `semactive` is 1, SEM installed
			if($details['semactive'] == '1'){
				return true;
			} else {
				return false;
			}
			
		} else {
			
			return false;
			
		}
		
	}// End function: semActive()
	
	/**
	 * Looks for the database table #__seo_opts, and returns true if it is present, and false otherwise.
	 * 
	 * @return Boolean TRUE if table exists, FALSE if not
	 */
	private function seoTableExists(){
					
		$db =& JFactory::getDBO();
		
		$table_name = $db->getPrefix() . 'seo_opts';
		
		$db->getPrefix();
		$query = $query = "show tables like '{$table_name}'";
		$db->setQuery( $query );
		$res = $db->loadAssoc();
		
		// A result will only be present if the SQL found a table with the required name
		if(is_array($res) && !empty($res)){
			return true;
		} else {
			return false;
		}
		
	}// End function: seoTableExists()

	

	private function getMonth($date) {

		return date('F', mktime(0, 0, 0, $date, 1, date('Y')));

	}

	

	private function getDay($day) {

		$day = ltrim($day, "0");

		

		$return = date('l', mktime(0, 0, 0, $this->selectedMonth, $day, date('Y'))).' ';

		$return .= $day;

		$return .= date('S', mktime(0, 0, 0, $this->selectedMonth, $day, date('Y'))).' ';

		$return .= date('F', mktime(0, 0, 0, $this->selectedMonth, 1, date('Y')));

		return $return;

	}

	

	public function getFilterForm() {

		echo '<h3>View Options</h3>';

		echo '<form action="index.php">';

		echo '<input type="hidden" name="section" value="google" />';

		echo '<input type="hidden" name="option" value="com_seo" />';

		echo '<label for="month"> Month </label>'; 

		echo '<select name="month" id="month" onchange="this.form.submit();">';

		$months = range(1, date('n'));

		foreach($months as $month){

			if ($month == $this->selectedMonth) {

				echo '<option selected="selected" value="'.$month.'">'.$this->getMonth($month).'</option>';

			}

			else {

				echo '<option value="'.$month.'">'.$this->getMonth($month).'</option>';

			}

		}

		echo '</select>';

		

		echo '&nbsp; &nbsp;<label for="view"> View </label>';

		$views = array("graph" => "Graphical","table" => "Tables");

		echo '<select name="display" id="view" onchange="this.form.submit();">';

		foreach ($views as $key => $value) {

			if ($key == $this->view) {

				echo '<option selected="selected" value="'.$key.'">'.$value.'</option>';

			}

			else {

				echo '<option value="'.$key.'">'.$value.'</option>';

			}

		} 

		echo '</select>';

		echo '</form><div class="clear">&nbsp;</div><br />';

	}

	

	public function getVisitors() {

		$records = $this->google->getVisitors();

		if ($this->view== "graph") {

			$js = "";

			foreach ($records as $key => $value) {

				$js .= "['".$key." ".$this->getMonth($this->selectedMonth)." ".date('Y')."',".$value."], \n";

			}

			$this->makeGraphChart("Unique Visitors in ".$this->getMonth($this->selectedMonth),rtrim($js,","),"visits");

		}

		else {

			echo '<div class="googleBrowsers">';

			echo '<div class="googleHead">Visitors in '.$this->getMonth($this->selectedMonth) .'</div>';

			echo '<div class="googleKey"><strong>Date</strong></div><div class="googleValue">#</div>';

			foreach ($records as $key => $value) {

			    echo '<div class="googleKey">'.$this->getDay($key).'</div>';

				echo '<div class="googleValue">'.$value.'</div>';

			}

			echo '<div class="clear">&nbsp;</div></div>';

		}

	}

	

	public function getPageViews() {

		$records = $this->google->getPageViews();

		if ($this->view== "graph") {

			$js = "";

			foreach ($records as $key => $value) {

				$js .= "['".$key." ".$this->getMonth($this->selectedMonth)." ".date('Y')."',".$value."], \n";

			}

			$this->makeGraphChart("Page Views in ".$this->getMonth($this->selectedMonth),rtrim($js,","),"pageVisits");

		}

		else {

			echo '<div class="googleBrowsers">';

			echo '<div class="googleHead">Page Views in '.$this->getMonth($this->selectedMonth) .'</div>';

			echo '<div class="googleKey"><strong>Date</strong></div><div class="googleValue">#</div>';

			foreach ($records as $key => $value) {

			    echo '<div class="googleKey">'.$this->getDay($key).'</div>';

				echo '<div class="googleValue">'.$value.'</div>';

			}

			echo '<div class="clear">&nbsp;</div></div>';

		}

	}

	

	public function getVisitsPerHour() {

		$records = $this->google->getVisitsPerHour();

		if ($this->view== "graph") {

			$lines = "";

			$tickers = "";

			foreach ($records as $key => $value) {

				//$js .= "['".$key." - ".$this->getMonth($this->selectedMonth)." - ".date('Y')."',".$value."], \n";

				$lines .= $value.',';

				$tickers .= "'".$key."'".',';

			}

			$this->makeBarChart("Page Visits Per Hour",rtrim($lines,","),rtrim($tickers,","),"pageVisitors");

		}

		else {

			echo '<div class="googleBrowsers" style="margin-right:0px;">';

			echo '<div class="googleHead">Page Visits Per Hour</div>';

			echo '<div class="googleKey"><strong>Hour</strong></div><div class="googleValue">#</div>';

			foreach ($records as $key => $value) {

			    echo '<div class="googleKey">'.$key.'</div>';

				echo '<div class="googleValue">'.$value.'</div>';

			}

			echo '<div class="clear">&nbsp;</div></div>';

		}

	}

	

	public function getBrowsers() {

		$records = $this->google->getBrowsers();

		

		if ($this->view== "graph") {

			$js = "";

			foreach ($records as $key => $value) {

				$js .= "['".$value." - ".$key."',".$value."],";

			}

			$this->makePieChart("Web Browser Statistics", $js,"browsers");

		}

		else {

			echo '<div class="googleBrowsers">';

			echo '<div class="googleHead">Web Browser Statistics</div>';

			echo '<div class="googleKey"><strong>Browser Version</strong></div><div class="googleValue">#</div>';

			foreach ($records as $key => $value) {

			    echo '<div class="googleKey">'.$key.'</div>';

				echo '<div class="googleValue">'.$value.'</div>';

			}

			echo '<div class="clear">&nbsp;</div></div>';

		}

	}

	

	public function getKeywords() {

		$records = $this->google->getSearchWords();

		if ($this->view== "graph") {

			$js = "";

			foreach ($records as $key => $value) {

				$js .= "['".$value." - ".$key."',".$value."],";

			}

			$this->makePieChart("Search Words", $js,"keywords");

		}

		else {

			echo '<div class="googleBrowsers">';

			echo '<div class="googleHead">Search Words</div>';

			echo '<div class="googleKey"><strong>Word</strong></div><div class="googleValue">#</div>';

			foreach ($records as $key => $value) {

			    echo '<div class="googleKey">'.$key.'</div>';

				echo '<div class="googleValue">'.$value.'</div>';

			}

			echo '<div class="clear">&nbsp;</div></div>';

		}

	}

	

	public function getRefferers() {

		$records = $this->google->getReferrers();

		if ($this->view== "graph") {

			$js = "";

			foreach ($records as $key => $value) {

				$js .= "['".$value." - ".$key."',".$value."],";

			}

			$this->makePieChart("Refferers", $js,"refferers");

		}

		else {

		echo '<div class="googleBrowsers" style="margin-right:0px;">';

		echo '<div class="googleHead">Refferers</div>';

		echo '<div class="googleKey"><strong>Refferer</strong></div><div class="googleValue">#</div>';

		foreach ($records as $key => $value) {

		    echo '<div class="googleKey">'.$key.'</div>';

			echo '<div class="googleValue">'.$value.'</div>';

		}

		echo '<div class="clear">&nbsp;</div></div>';

		}

	}

	

	public function getResolutions() {

		$records = $this->google->getScreenResolution();

		if ($this->view== "graph") {

			$js = "";

			foreach ($records as $key => $value) {

				$js .= "['".$value." - ".$key."',".$value."],";

			}

			$this->makePieChart("Screen Resolutions", $js,"resolutions");

		}

	}

	

	private function makePieChart($title,$js,$id) {

		echo "

			<script type=\"text/javascript\" language=\"javascript\">

				jQuery(document).ready(function(){

					var ".$id.";

					".$id." = jQuery.jqplot('".$id."', [[ ".$js." ]], {

						title: {

					        text: '".$title."',   // title for the plot,

					        show: true,

							textAlign: 'left',

					    },

						seriesColors:  ['#dcd630', '#c8a035', '#c53f3f', '#ae2525', '#6c9d4a', '#4d782f', '#63a2c9', '#2f6899', '#a46da7', '#833787', '#848484', '#636363'],

				      	seriesDefaults:{ renderer:jQuery.jqplot.PieRenderer, rendererOptions:{shadowOffset:2,shadowDepth:3,padding:2,diameter:250 }, trendline:{show:true} },

				      	legend:{show:true},

						gridPadding: {top:2, right:2, bottom:2, left:2},

					  	grid:{shadow:false,shadowOffset:0 , borderWidth:0, background:'#fff'},

					  	axes:{pad:0}      

			    	});

				});

			</script>

		";

		echo '



				<div id="'.$id.'" style="width:450px; float:left; ">

					

				</div>

		';

	}

	

	private function makeGraphChart($title,$js,$id) {

		echo "

			<script type=\"text/javascript\" language=\"javascript\">

				jQuery(document).ready(function(){

					var ".$id.";

   					".$id." = jQuery.jqplot('".$id."',[[".$js."]],{

	      				title: {

					        text: '".$title."', 

					        show: true,

							textAlign: 'left',

					    },

	       				axes: { 

							xaxis: { renderer: jQuery.jqplot.DateAxisRenderer, tickOptions: { formatString: '%b %#d' },

	               			numberTicks: 20

	           			},

	           			yaxis: { tickOptions: { } }

      				},

       

       				cursor: { show: false },

					axesDefaults: { tickOptions: { formatString: '%d' } },

					grid:{shadow:false,shadowOffset:0 , borderWidth:0, background:'#fff'}

   					});

				});

			</script>

		";

		echo '

			<div id="'.$id.'" style="margin-top:0px; width:100%; height:400px;"></div>

			<br />

			<hr />

			<br />

		';

	}

	

	private function makeBarChart($title,$line,$tickers,$id) {

		echo "

			<script type=\"text/javascript\" language=\"javascript\">

				jQuery(document).ready(function(){

					jQuery.jqplot.config.enablePlugins = true;

   					var line1 = [".$line."];

					var tickers = [".$tickers."];

					var ".$id.";		

					".$id." = jQuery.jqplot('".$id."', [line1], {

							stackSeries: true,

							legend: {

								show: true,

								//location: 'ne'

							},

							title: {

						        text: '".$title."',   // title for the plot,

						        show: true,

								textAlign: 'left',

						    },

							seriesDefaults: {

								renderer: jQuery.jqplot.BarRenderer,

								rendererOptions: {

				                    // barPadding: 6,

				          // barMargin: 15,

				          //barWidth: 3

								}

				        // shadowAngle: 135

							},

							series: [{

								label: 'Hits'

							}],

							axes: {

								xaxis: {

									renderer: jQuery.jqplot.CategoryAxisRenderer,

				          ticks: tickers         

								},

								yaxis: {

									min: 0

								}

							},

							axesDefaults: { tickOptions: { formatString: '%d' } },

							grid:{shadow:false,shadowOffset:0 , borderWidth:0, background:'#fff'},

					});

				});

			</script>

		";

		echo '

			<div id="'.$id.'" style="margin-top:0px; margin-left:0px; width:100%; height:400px;"></div>

			<br />

			<hr />

			<br />

		';

	}



}



?>